]> git.pld-linux.org Git - packages/rpm-pld-macros.git/blame_incremental - rpm.macros
- 1.630: cacti-0.8.7g/cacti-0.8.7h compat for %cacti_import_template
[packages/rpm-pld-macros.git] / rpm.macros
... / ...
CommitLineData
1# $Revision$, $Date$
2# vim:ts=4 sw=4 noet ft=spec
3#
4# PLD Linux rpm macros.
5# <http://www.pld-linux.org/>
6
7# can be used by builder script to check for version
8%rpm_build_macros %(R="$Revision$"; RR="${R##: }"; echo ${RR%%?})
9
10%epoch 0
11%x8664 x86_64 amd64 ia32e
12%arm armv3l armv4b armv4l armv5teb armv5tel
13
14# kernel compiler
15%kgcc %{__cc}
16%kgcc_package gcc
17
18# compiler version
19%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion 2>/dev/null || echo 0.0)}%cc_version
20%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion 2>/dev/null || echo 0.0)}%cxx_version
21
22%__rm /bin/rm --interactive=never
23
24# Build system path macros.
25%__autoconf autoconf %{?debug:-Wall}
26%__automake automake -a -c -f --foreign
27%__autopoint autopoint --force
28
29# add parallel build flags: -jN
30#
31# if you want to disable parallel build do:
32# echo '%_smp_mflags %{nil}' >> ~/.rpmmacros
33#
34%__make /usr/bin/make %{?_smp_mflags}
35%__scons /usr/bin/scons %{?_smp_mflags}
36%__waf /usr/bin/waf %{?_smp_mflags}
37%__cmake /usr/bin/cmake
38
39%_smp_mflags %(_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); \\\
40 [ "$_NCPUS" -gt 1 ] && echo "-j$(($_NCPUS * 2))")
41
42%__gettextize { \
43 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
44 gettextize --copy --force --no-changelog; \
45 else \
46 gettextize --copy --force --no-changelog --intl; \
47 fi; \
48 if [ ! -f po/Makevars ]; then \
49 cp -f po/Makevars{.template,}; \
50 fi; \
51}
52
53%__glib_gettextize glib-gettextize --copy --force
54%__gnome_doc_common gnome-doc-common --copy
55%__gnome_doc_prepare gnome-doc-prepare --copy --force
56%__gtkdocize gtkdocize --copy
57%__intltoolize intltoolize --copy --force
58%__libtoolize libtoolize --copy --force --install
59
60# topdir is where builder script lives,
61# fallback to old style if SPECS/SOURCES dirs were found.
62%_topdir %{expand:%%global _topdir %(
63 if [ -d SPECS -a -d SOURCES ]; then
64 # old style rpmdir: in topdir
65 pwd
66 elif [ -d ../SPECS -a -d ../SOURCES ]; then
67 # old style rpmdir: in subdir
68 cd ..; pwd
69 elif [ -d $HOME/rpm/SPECS -a -d $HOME/rpm/SOURCES ]; then \
70 # if old style rpm dir exist, go with it
71 echo $HOME/rpm; \
72 elif [ -x ../builder -a ! -d ../builder ]; then
73 # relative new style rpmdir: in package dir
74 cd ..; pwd
75 elif [ -x builder -a ! -d builder ]; then
76 # relative new style rpmdir: in packages
77 pwd
78 elif [ -x packages/builder -a ! -d packages/builder ]; then
79 # relative new style rpmdir: packages dir in current dir
80 cd packages; pwd
81 else
82 # fallback to new style rpmdir
83 echo $HOME/rpm/packages
84 fi; \
85)}%_topdir
86
87# if %{_topdir}/SPECS exists, it's old style structure
88%_specdir %{expand:%%global _specdir %([ ! -d %{_topdir}/SPECS ] && echo %{_topdir}/%{name} || echo %{_topdir}/SPECS)}%_specdir
89%_sourcedir %{expand:%%global _sourcedir %([ ! -d %{_topdir}/SOURCES ] && echo %{_specdir} || echo %{_topdir}/SOURCES)}%_sourcedir
90
91# BUILD/RPMS/SRPMS are one same level by default as packages dir, if these exist
92# if they don't exist assume we are having custom topdir (which is not named as
93# "packages", i.e ~/rpm/kde/{kdelibs,BUILD/RPMS/SRPMS})
94# NOTE: readlink fails if some parent dir is not readable (/home/services/builder for example can't read /home/services), therfore the extra echo
95%_builddir %{expand:%%global _builddir %(if [ -d %{_topdir}/BUILD ]; then echo %{_topdir}/BUILD; else readlink -m %{_topdir}/../BUILD || echo %{_topdir}/../BUILD; fi)}%_builddir
96%_rpmdir %{expand:%%global _rpmdir %(if [ -d %{_topdir}/RPMS ]; then echo %{_topdir}/RPMS; else readlink -m %{_topdir}/../RPMS || echo readlink -m %{_topdir}/../RPMS; fi)}%_rpmdir
97%_srcrpmdir %{expand:%%global _srcrpmdir %(if [ -d %{_topdir}/SRPMS ]; then echo %{_topdir}/SRPMS; else readlink -m %{_topdir}/../SRPMS || echo readlink -m %{_topdir}/../SRPMS; fi)}%_srcrpmdir
98
99# The number of cvs changelog entries kept when building package.
100%_buildchangelogtruncate 20
101
102%dependencytracking %{nil}
103
104# Relations between package names that cause dependency loops
105# with legacy packages that cannot be fixed. Relations are
106# specified as
107# p>q
108# where package p has a Requires: on something that package q Provides:
109#
110# XXX Note: that there cannot be any whitespace within the string "p>q",
111# and that both p and q are package names (i.e. no version/release).
112%_dependency_whiteout %{nil}
113
114#-----------------------------------------------------------------
115#
116# (re)definition of %{rpm*flags} with %filterout_* support
117# BuildRequires: awk
118# BuildRequires: rpmbuild(macros) >= 1.315
119#
120# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
121# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
122# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
123# %rpmcppflags = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
124# %rpmldflags = %optldflags - %filterout_ld
125#
126# Regular expressions are supported, but to avoid some character be treated
127# as regular expression it must be escaped twice.
128
129%filter_out \
130 for (i = 1; i in I; i++) { A=0; \
131 for (f in F) { \
132 if (I[i] ~ "^" F[f] "$") A=1; \
133 }; \
134 if (!A) printf(I[i] FS); \
135 }
136
137%rpmcflags %(awk 'BEGIN {
138 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
139 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
140 %{filter_out}
141}')
142
143%rpmcxxflags %(awk 'BEGIN {
144 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
145 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
146 %{filter_out}
147}')
148
149%rpmcppflags %(awk 'BEGIN {
150 split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
151 split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
152 %{filter_out}
153}')
154
155%rpmldflags %(awk 'BEGIN {
156 split("%{?optldflags}",I);
157 split("%{?filterout_ld}",F)
158 %{filter_out}
159}')
160
161# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
162# but, don't use it, better use gcc as linker
163%ld_rpmldflags %(awk 'BEGIN {
164 split("%{rpmldflags}",F);
165 for (f in F) {
166 s = F[f];
167 if (s ~ /^-Wl,/) {
168 s = substr(s,5);
169 gsub(/,/," ",s);
170 };
171 printf(s FS);
172 };
173}')
174
175#-----------------------------------------------------------------
176#
177# Generate a command which cleans environment, leaving only the
178# most important variables.
179# If any spec requires any additional environment it should
180# redefine %_preserve_env in following manner:
181#
182# # ADDITIONAL_VAR is required because [a good reason here]
183# %define _preserve_env ADDITIONAL_VAR
184
185%_preserve_env_base PATH HOME TMP TMPDIR SSH_AUTH_SOCK
186
187# "env -i" must end in first line of expaned macros because it's used as first line of shell script (#! env...)
188%_clean_env %{!?_preserve_env:%global _preserve_env %{nil}}%{expand:%%global _preserve_env %{_preserve_env} %_preserve_env_base} env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
189 split("%{?_preserve_env}", P);
190 for (i in P) {
191 p = P[i];
192 if (!ENVIRON[p] || d[p]) {
193 continue;
194 }
195 d[p] = 1;
196 split(ENVIRON[p], V, "");
197 val = p "=";
198 for (j = 1; j in V; j++) {
199 v = V[j];
200 if (v == q)
201 v = qq;
202 else if (v == "\\"")
203 v = q2q;
204 else if (v == "\\\\")
205 v = "\\\\\\\\";
206 else
207 gsub("[^a-zA-Z0-9/:._-]", "\\"&\\"", v);
208 val = val "" v;
209 }
210 printf(val " ");
211 }
212}')
213
214#-----------------------------------------------------------------
215%configure2_13 { \
216 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
217 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
218 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
219 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
220 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
221 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
222 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
223 %{?__cc:CC="%{__cc}" ; export CC ; } \
224 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
225 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
226 --host=%{_target_platform} \
227 --prefix=%{_prefix} \
228 --exec-prefix=%{_exec_prefix} \
229 --bindir=%{_bindir} \
230 --sbindir=%{_sbindir} \
231 --sysconfdir=%{_sysconfdir} \
232 --datadir=%{_datadir} \
233 --includedir=%{_includedir} \
234 --libdir=%{_libdir} \
235 --libexecdir=%{_libexecdir} \
236 --localstatedir=%{_localstatedir} \
237 --sharedstatedir=%{_sharedstatedir} \
238 --mandir=%{_mandir} \
239 --infodir=%{_infodir} \
240 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
241 %{dependencytracking} \
242}
243
244%cmake \
245%{?__cc:CC="%{__cc}"} \\\
246%{?__cxx:CXX="%{__cxx}"} \\\
247CPPFLAGS="${CPPFLAGS:-%{rpmcppflags}}" \\\
248%{__cmake} \\\
249 -DCMAKE_VERBOSE_MAKEFILE=ON \\\
250 -DCMAKE_BUILD_TYPE=%{!?debug:PLD}%{?debug:Debug} \\\
251 -DCMAKE_INSTALL_LIBDIR:PATH=%{_libdir} \\\
252 -DCMAKE_INSTALL_PREFIX:PATH=%{_prefix} \\\
253 -DINCLUDE_INSTALL_DIR:PATH=%{_includedir} \\\
254 -DLIB_INSTALL_DIR:PATH=%{_libdir} \\\
255 -DSHARE_INSTALL_PREFIX:PATH=%{_datadir} \\\
256 -DSYSCONF_INSTALL_DIR:PATH=%{_sysconfdir} \\\
257 -DCMAKE_CXX_FLAGS_PLD="${CXXFLAGS:-%{rpmcxxflags} -DNDEBUG}" \\\
258 -DCMAKE_C_FLAGS_PLD="${CFLAGS:-%{rpmcflags} -DNDEBUG}" \\\
259 -DCMAKE_Fortran_FLAGS_PLD="${CFLAGS:-%{rpmcflags} -DNDEBUG}" \\\
260 -DCMAKE_EXE_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
261 -DCMAKE_SHARED_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
262 -DCMAKE_MODULE_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
263%if "%{_lib}" == "lib64" \
264 -DLIB_SUFFIX=64 \\\
265%endif \
266 -DBUILD_SHARED_LIBS:BOOL=ON \\\
267%{nil}
268
269%scons { \
270%{__scons} \
271 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
272 CFLAGS="${CFLAGS:-%rpmcflags}" \
273 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
274 FFLAGS="${FFLAGS:-%rpmcflags}" \
275 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
276 %{?__cc:CC="%{__cc}"} \
277 %{?__cxx:CXX="%{__cxx}"} \
278 libsuffix=%{_lib} \
279 prefix=%{_prefix} \
280}
281
282# waf. see waf.spec
283%waf { \
284CC="%{__cc}" \
285CXX="%{__cxx}" \
286CPP="%{__cpp}" \
287CFLAGS="%{rpmcflags}" \
288CXXFLAGS="%{rpmcxxflags}" \
289%{__waf} \
290}
291
292#----------------------------------------------------------------
293#%configure_cache 0
294%configure_cache_file %{buildroot}.configure.cache
295
296%configure {./configure \
297 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
298 CFLAGS="${CFLAGS:-%rpmcflags}" \
299 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
300 FFLAGS="${FFLAGS:-%rpmcflags}" \
301 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
302 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
303 %{?__cc:CC="%{__cc}"} \
304 %{?__cxx:CXX="%{__cxx}"} \
305 --host=%{_target_platform} \
306 --build=%{_target_platform} \
307 --prefix=%{_prefix} \
308 --exec-prefix=%{_exec_prefix} \
309 --bindir=%{_bindir} \
310 --sbindir=%{_sbindir} \
311 --sysconfdir=%{_sysconfdir} \
312 --datadir=%{_datadir} \
313 --includedir=%{_includedir} \
314 --libdir=%{_libdir} \
315 --libexecdir=%{_libexecdir} \
316 --localstatedir=%{_localstatedir} \
317 --sharedstatedir=%{_sharedstatedir} \
318 --mandir=%{_mandir} \
319 --infodir=%{_infodir} \
320 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
321 %{dependencytracking} \
322 %{?configure_cache:--cache-file=%{configure_cache_file}} \
323}
324
325# Simple macros to simplify adding bconded options to configure scripts.
326# Each macro requires bcond name and accepts optional option name, if option
327# isn't specified bcond name is used as option name. Options returning
328# --with and --enable also allow third argument which will be added as value
329# ( --with-option=value or --enable-option=value ) in case or positive
330# condition, but won't be added otherwise ( nothing or just --disable-option ).
331
332# Requirements:
333# BuildRequires: rpmbuild(macros) >= 1.527
334
335# Usage example:
336# %{__enable bcond} - returns --enable-bcond iff build condition is set
337# %{__disable bcond option} - returns --enable-option iff bcond is not set
338# %{__enable_disable bcond option value} - returns --enable-option=value if
339# bcond is set, returns --disable-option otherwise
340
341# expand bconds to --enable-something and --disable-something
342%__enable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
343%__disable() %{expand:%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
344%__enable_disable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
345
346# same as above, but condition inverted
347%__enable_unless() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
348%__disable_if() %{expand:%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
349%__enable_disable_not() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
350
351# expand bconds to --with-something and --without-something
352%__with() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
353%__without() %{expand:%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
354%__with_without() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
355
356# same as above, but condition inverted
357%__with_unless() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
358%__without_if() %{expand:%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
359%__with_without_not() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
360
361#-----------------------------------------------------------------
362
363# overload to insert debuginfo package
364%prep \
365%if 0%{?_enable_debug_packages}\
366%{debug_package}\
367%endif\
368%%prep\
369%{nil}
370
371# Location of autoconf macros
372%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir 2>/dev/null || echo ERROR)}%_aclocaldir
373
374# Location of omf files
375%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
376
377# Location of pkgconfig files
378%_pkgconfigdir /usr/%{_lib}/pkgconfig
379# noarch pkgconfig files
380%_npkgconfigdir /usr/share/pkgconfig
381
382# Location of desktop files
383%_desktopdir /usr/share/applications
384%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
385
386# Location of pixmaps for applnk/desktop files
387%_pixmapsdir /usr/share/pixmaps
388
389# Location of themable icons for applnk/desktop files
390%_iconsdir /usr/share/icons
391
392# Location of fonts directories
393%_fontsdir /usr/share/fonts
394
395# Location of Gtk and associated libraries documentation
396%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
397
398# Location of KDE documentation
399%_kdedocdir %{_defaultdocdir}/kde/HTML
400
401# unsermake script
402%__unsermake /usr/share/unsermake/unsermake
403
404# Current date
405%date %(LC_ALL=C date +"%a %b %d %Y")
406
407# Example files, programs, scripts...
408%_examplesdir /usr/src/examples
409
410# Alternative kernel type/version
411%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
412
413# The directory holding Linux kernel sources
414%_kernelsrcdir /usr/src/linux%{_alt_kernel}
415
416# SysV-style initscripts dir
417%_initddir /etc/rc.d/init.d
418
419# If non-empty "debug" macro defined, add "dbg" suffix to release number
420%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
421
422# Bootstrap release macros.
423# Usage:
424# %bcond_with bootstrap
425# Release: %{bootstrap_release 1}
426#
427# Package will have release 1 if built normally,
428# and release 0.zzz.bootstrap if built with bootstrap
429%bootstrap_release() %{!?with_bootstrap:%{1}%{?2:.%{2}}}%{?with_bootstrap:%{!?2:%(expr %{1} - 1)}%{?2:%{1}.%(expr %{2} - 1)}.zzz.bootstrap}
430
431# -n drm to generate kernel%{_alt_kernel}-drm dependency
432%releq_kernel(n:) %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
433%releq_kernel_up(n:) %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
434%releq_kernel_smp(n:) %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
435
436# -s post to generate Requires(post) dependency
437%requires_releq_kernel(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel
438%requires_releq_kernel_up(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_up
439%requires_releq_kernel_smp(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
440
441# Requires name = version-release
442%requires_releq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to -r %1 %1}}}
443# Requires: name = version
444%requires_eq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to %1 %1}}}
445# Requires: name = version (version based on querying package %2)
446%requires_eq_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
447
448# Requires: name >= version
449%requires_ge() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_ge_to %1 %1}}}
450# Requires: name >= version (version based on querying package %2)
451%requires_ge_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 >= %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
452
453%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
454
455# kernel version-release handling
456%__kernel_ver %{expand:%%global __kernel_ver %( \\
457 Z=$([ -f '%{_kernelsrcdir}/include/generated/utsrelease.h' ] && awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/{linux/version,generated/utsrelease}.h 2>/dev/null || awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
458 Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
459 echo ${Z:-ERROR}; \\
460)}%__kernel_ver
461
462%__kernel_rel %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
463%__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
464%_kernel_ver %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
465%_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
466
467# `uname -r` to be used in @release field
468%_kernel_vermagic %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
469
470# sgml macros
471%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
472%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
473%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
474%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
475%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
476%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
477%docbook_sgmlcat_fix() { for l in \
478'' \
479' -- default decl --' \
480'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
481' -- hacks for opensp --' \
482'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
483'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
484'' \
485; do echo $l; done >> %1 \
486}
487
488# vim - "
489
490# minimum file size needed for compressed documents.
491# just smaller files than this get larger when compressed.
492# some stats:
493# - 0 byte file compressed was 25 bytes .gz
494# - 39 byte file was compressed as 57
495# - with test/test.spec@man 158 byte file was compressed also 158
496%_min_compress_bytes 159
497
498#-----------------------------------------------------------------
499# find and gzip all files in %{_mandir} and %{infodir}
500#
501# Requires: xargs, find
502#
503#%no_install_post_compress_docs 1
504%__spec_install_post_compress_docs { \
505%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
506 %{!?debug:set +x;} \
507 for i in /usr/share/man /usr/X11R6/man; do \
508 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
509 echo "Compress man pages: $i"; \
510 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
511 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
512 find $RPM_BUILD_ROOT$i -type l | while read a; do \
513 m=$(readlink "$a"); \
514 if [[ "$m" = */* ]]; then \
515 # handle links to different man section \
516 l=$(readlink -f "$a"); \
517 # full/relative paths that resolve symlink \
518 l=${l#$RPM_BUILD_ROOT/usr/share/man/}; \
519 l=${l#$RPM_BUILD_ROOT/usr/X11R6/man/}; \
520 # full paths that do not resolve symlink \
521 l=${l#/usr/share/man/}; \
522 l=${l#/usr/X11R6/man/}; \
523 else \
524 l=$m; \
525 fi; \
526 rm -f $a; \
527 echo ".so $l" > $a; \
528 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: $l"; \
529 done; \
530 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
531 fi; \
532 done; \
533 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
534 echo "Compress info pages: %{_infodir}"; \
535 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
536 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
537 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
538 fi; \
539}; __spec_install_post_compress_docs } }
540
541#-----------------------------------------------------------------
542# Strip executable binaries and shared object files
543#
544# Requires: find, awk, strip, cut, xargs
545#
546# Special macros which affect this process:
547#%no_install_post_strip 1 # disable stripping at all
548#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
549#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
550#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
551#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
552#
553%__spec_install_post_strip {%{!?debug: \
554%{!?no_install_post_strip:__spec_install_post_strip() { \
555%{!?debug:set +x;} \
556if [ -d "$RPM_BUILD_ROOT" ]; then \
557 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
558 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
559 if [ "$modulelist" ]; then \
560 modulecount=$(echo "$modulelist" | wc -l); \
561 printf "Stripping %d kernel modules..." $modulecount; \
562 echo "$modulelist" | xargs -l512 chmod u+w; \
563 echo "$modulelist" | xargs -l512 %{__strip} -g --remove-section=.comment --remove-section=.note.GNU-stack; \
564 echo "DONE"; \
565 fi; \
566 fi; \
567 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
568 if [ -n "$filelist" ]; then \
569 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
570 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
571 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
572 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
573 if [ -n "$elfexelist" ]; then \
574 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
575 echo "$elfexelist" | xargs -r -d'\n' chmod u+w; \
576 echo "$elfexelist" | xargs -r -d'\n' %{__strip} --remove-section=.note --remove-section=.comment; \
577 echo "DONE"; \
578 fi; \
579 if [ -n "$elfsharedlist" ]; then \
580 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
581 echo "$elfsharedlist" | xargs -r -d'\n' chmod u+w; \
582 echo "$elfsharedlist" | xargs -r -d'\n' %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment; \
583 echo "DONE"; \
584 fi; \
585 if [ -n "$archiveslist" ]; then \
586 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
587 echo "$archiveslist" | xargs -r -d'\n' chmod u+w; \
588 echo "$archiveslist" | xargs -r -d'\n' %{__strip} --strip-debug --remove-section=.note --remove-section=.comment; \
589 echo "DONE"; \
590 fi; \
591 fi; \
592 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
593 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
594 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
595 if [ -n "$filelist_all" ]; then \
596 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
597 chmod u+w $filelist_all; \
598 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
599 echo "DONE"; \
600 fi; \
601 if [ -n "$filelist_unneeded" ]; then \
602 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
603 chmod u+w $filelist_unneeded; \
604 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
605 echo "DONE"; \
606 fi; \
607 if [ -n "$filelist_debug" ]; then \
608 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
609 chmod u+w $filelist_debug; \
610 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
611 echo "DONE"; \
612 fi; \
613fi; }; __spec_install_post_strip } } }
614
615#-----------------------------------------------------------------
616# remove all RPATH from executable binaries and shared object files
617#
618# Requires: find, awk, cut, xargs, chrpath, uname
619#
620# Special macros which affect this process
621#%no_install_post_chrpath 1 # disable chrpath at all
622#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
623#
624%__spec_install_post_chrpath {%{!?debug: \
625%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
626%{!?debug:set +x;} \
627if [ -d "$RPM_BUILD_ROOT" ]; then \
628 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
629 if [ -n "$files" ]; then \
630 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
631 fi; \
632 if [ -n "$objs" ]; then \
633 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
634 echo "$objs" | \
635 while read file; do \
636 rpath= ; \
637 chmod u+w "$file"; \
638 for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
639 case $dir in \
640 '$ORIGIN' ) \
641 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
642 else rpath="$rpath:$dir" ; fi ; \
643 continue ; \
644 ;; \
645 esac ; \
646 newdir=$(readlink -m "$dir"); \
647 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
648 case $dir in \
649 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
650 echo "remove-rpath: $dir in $file"; \
651 ;; \
652 * ) \
653 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
654 else rpath="$rpath:$dir" ; fi ; \
655 ;; \
656 esac ; \
657 done ; \
658 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
659 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
660 done; \
661 fi; \
662fi; }; __spec_install_post_chrpath } } }
663
664# vim: "
665
666#-----------------------------------------------------------------
667# Find all shared object files with unresolved symbols. Warn
668# and terminate if any found (termination can be turned off by define).
669#%no_install_post_check_so 1
670#%skip_post_check_so libwithunresolvedok.so.*
671#
672# NOTE: define skip_post_check_so only if such library really requires
673# unresolved symbols and always leave a comment why it is required:
674# # executable provides symbols foo, bar for those libraries:
675# %define skip_post_check_so libwithoutfoo.so.* libwithoutbar.so.*
676#
677%__spec_install_post_check_so { \
678__spec_install_post_check_so() { \
679%{!?debug:set +x;} \
680 fail=0; \
681 printf "Searching for shared objects with unresolved symbols..."; \
682 for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
683 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; %{?skip_post_check_so:split("%{skip_post_check_so}", R); for (i=1; i in R; i++) { if (file ~ "(^|/)" R[i] "$") { print "Library marked with skip_post_check_so, ignoring errors.\n"; exit(0); } } } exit(1); } } ' || fail=1 ; \
684 done ; \
685 echo " DONE"; \
686 %{!?no_install_post_check_so:return $fail;} \
687}; __spec_install_post_check_so }}
688
689#-----------------------------------------------------------------
690# Find and gzip all kernel modules
691#
692# Requires: find
693#
694#%no_install_post_compress_modules 1
695%__spec_install_post_compress_modules { \
696%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
697%{!?debug:set +x;} \
698 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
699 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
700 if [ "$q" ]; then \
701 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
702 echo "$q" | xargs -r %{__gzip} -9nf; \
703 echo "DONE"; \
704 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
705 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
706 fi; \
707 fi; \
708}; __spec_install_post_compress_modules } }
709
710# Remove common Perl files we don't package
711%__spec_install_post_perl_clean {\
712%{!?no_install_post_perl_clean: \
713%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
714} }
715
716#-----------------------------------------------------------------
717# Update GConf2 schemas
718#
719# Requires: GConf2
720#
721%gconf_schema_install() \
722 umask 022; \
723 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
724 /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
725%{nil}
726
727%gconf_schema_uninstall() \
728if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
729 umask 022; \
730 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
731 /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
732fi; \
733%{nil}
734
735#-----------------------------------------------------------------
736# Update desktop MIME database
737# requires: desktop-file-utils
738%update_desktop_database() {{ \
739 umask 022; \
740 /usr/bin/update-desktop-database -q; \
741};} \
742%{nil}
743
744%update_desktop_database_post %update_desktop_database
745
746%update_desktop_database_postun() {{ \
747if [ "$1" = "0" ]; then \
748 %update_desktop_database \
749fi; \
750};} \
751%{nil}
752
753#-----------------------------------------------------------------
754# Update shared MIME info database
755# requires: shared-mime-info
756#
757%update_mime_database() {{ \
758 umask 022; \
759 /usr/bin/update-mime-database %{_datadir}/mime; \
760};} \
761%{nil}
762
763#-----------------------------------------------------------------
764# Update icon cache
765# BuildRequires: rpmbuild(macros) >= 1.596
766# Requires: hicolor-icon-theme
767#
768%update_icon_cache() {{ \
769 %{!?1:%{error:%{0}: Required theme name missing}} \
770 if [ -x /usr/bin/gtk-update-icon-cache ]; then \
771 umask 022; \
772 touch --no-create %{_iconsdir}/%1; \
773 /usr/bin/gtk-update-icon-cache -qf %{_iconsdir}/%1; \
774 fi; \
775};} \
776%{nil}
777
778#-----------------------------------------------------------------
779# Update scrollkeeper database
780# requires: scrollkeeper
781#
782%scrollkeeper_update_post() \
783 /usr/bin/scrollkeeper-update -q; \
784%{nil}
785
786%scrollkeeper_update_postun() \
787if [ "$1" = "0" ]; then \
788 /usr/bin/scrollkeeper-update -q; \
789fi; \
790%{nil}
791
792#-----------------------------------------------------------------
793# Compile GSettings schemas
794# requires: glib2 >= 1:2.26.0
795#
796%glib_compile_schemas() {{ \
797 umask 022; \
798 /usr/bin/glib-compile-schemas %{_datadir}/glib-2.0/schemas; \
799};} \
800%{nil}
801
802#-----------------------------------------------------------------
803# post %install sequence:
804# - autodeps exceptions
805# - compress all man and info pages,
806# - strip all ELF executables and ELF shared objects if not %debug.
807# - compress kernel modules if any
808
809###################################################################
810# Requires/Provides automation
811# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
812#
813%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
814%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
815%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
816%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
817%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
818
819#%_noautocompressdoc %{nil}
820#
821%_missing_doc_files_terminate_build 1%{nil}
822%_unpackaged_files_terminate_build %{nil}
823# (X)emacs support
824%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
825%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
826%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
827
828%__php_provides %{nil}
829%__php_requires %{nil}
830%__perl_provides %{nil}
831%__perl_requires %{nil}
832%__mono_provides %{nil}
833%__mono_requires %{nil}
834
835# Perl specific macro definitions.
836%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
837%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
838%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
839%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
840%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
841%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
842
843# Ruby
844%__ruby /usr/bin/ruby
845%ruby_archdir %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
846%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
847%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
848%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
849%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
850%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
851%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
852%ruby_rdocdir /usr/share/rdoc
853%ruby_version %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
854%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
855%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
856
857%php_pear_dir /usr/share/pear
858%php_data_dir /usr/share/php
859%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
860%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
861%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
862
863# extract php/zend api versions
864%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
865%php_minor_version %{expand:%%global php_minor_version %(awk '/#define PHP_MINOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_minor_version
866%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
867%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
868%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
869%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
870%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
871%_zend_zts %{expand:%%global _zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%_zend_zts
872# "_ts" if ZTS enabled, empty otherwise
873%zend_zts %{expand:%%global _zend_zts_%{?_zend_zts} 1}%{?_zend_zts_1:_ts}
874
875# helper macro
876%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
877
878# macros for public use
879# for php extensions (php-pecl)
880%requires_php_extension %{__php_api_requires modules_api php_api_version} \
881%{__php_api_requires zend_module_api} \
882%{__php_api_requires -v %php_major_version debug php_debug} \
883%{__php_api_requires -v %php_major_version thread-safety _zend_zts}
884
885# for zend extensions
886%requires_zend_extension %{__php_api_requires zend_module_api} \
887%{__php_api_requires zend_extension_api} \
888%{__php_api_requires -v %php_major_version debug php_debug} \
889%{__php_api_requires -v %php_major_version thread-safety _zend_zts}
890
891# for php pdo modules (php-pecl-PDO_*)
892%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
893
894# for using PHP post scripts. for PHP >= 5.0
895%php_webserver_restart \
896[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
897[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
898if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
899 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
900 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
901 %service -q php-fcgi restart \
902 fi \
903fi \
904if [ -x /etc/rc.d/init.d/php-fpm ]; then \
905 %service -q php-fpm restart \
906fi \
907%{nil}
908
909# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
910%php4_webserver_restart \
911[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
912[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
913if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
914 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
915 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
916 %service -q php-fcgi restart \
917 fi \
918fi \
919%{nil}
920
921# X.org helper macros
922%__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
923%__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
924
925%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
926%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
927%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
928%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
929%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
930# vim: '
931
932%requires_xorg_xserver_extension \
933%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
934%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
935%{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
936%{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
937%{nil}
938
939%requires_xorg_xserver_xinput \
940%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
941%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
942%{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
943%{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
944%{nil}
945
946%requires_xorg_xserver_font \
947%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
948%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
949%{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
950%{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
951%{nil}
952
953%requires_xorg_xserver_videodrv \
954%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
955%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
956%{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
957%{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
958%{nil}
959
960# TCL specific macro definitions.
961# TODO: when th tcl is fixed use tclsh to get version: %(echo 'puts $tcl_version' | tclsh)
962%tcl_version %{expand:%%global tcl_version %(v=$(rpm -q --qf %{V} tcl | cut -d. -f1,2); echo ${v:-ERROR})}%tcl_version
963%tcl_sitearch %{_libdir}/tcl%{tcl_version}
964%tcl_sitelib %{_datadir}/tcl%{tcl_version}
965
966# Python specific macro definitions.
967# python main version
968%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
969
970# directories
971%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
972%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
973%py_scriptdir %{py_prefix}/share/python%{py_ver}
974%py_incdir /usr/include/python%{py_ver}
975%py_sitedir %{py_libdir}/site-packages
976%py_sitescriptdir %{py_scriptdir}/site-packages
977%py_dyndir %{py_libdir}/lib-dynload
978
979# pure python modules compilation
980%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
981
982%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
983
984# Software written in Python language require Python with main version
985%pyrequires_eq() Requires: %1
986
987# Python 3.x
988# python main version
989%__python3 python3
990%py3_ver %{expand:%%global py3_ver %(%{__python3} -c "import sys; print(sys.version[:3])" 2>/dev/null || echo ERROR)}%py3_ver
991
992# directories
993%py3_prefix %{expand:%%global py3_prefix %(%{__python3} -c "import sys; print(sys.prefix)" 2>/dev/null || echo ERROR)}%py3_prefix
994%py3_libdir %{expand:%%global py3_libdir %(%{__python3} -c "import sysconfig; print(sysconfig.get_path('platstdlib'))" 2>/dev/null || echo ERROR)}%py3_libdir
995%py3_incdir %{expand:%%global py3_incdir %(%{__python3} -c "import sysconfig; print(sysconfig.get_path('include'))" 2>/dev/null || echo ERROR)}%py3_incdir
996%py3_sitedir %{expand:%%global py3_sitedir %(%{__python3} -c "import sysconfig; print(sysconfig.get_path('platlib'))" 2>/dev/null || echo ERROR)}%py3_sitedir
997%py3_sitescriptdir %{expand:%%global py3_sitescriptdir %(%{__python3} -c "import sysconfig; print(sysconfig.get_path('purelib'))" 2>/dev/null || echo ERROR)}%py3_sitescriptdir
998%py3_scriptdir %{py3_prefix}/share/python%{py3_ver}
999%py3_dyndir %{py3_libdir}/lib-dynload
1000
1001# pure python modules compilation
1002%py3_comp %{__python3} -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
1003
1004%py3_ocomp %{__python3} -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
1005
1006
1007# Hardlink binary identical .pyc and .pyo files
1008%__spec_install_post_py_hardlink {\
1009%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
1010%{!?debug:set +x;} \
1011local a b c=0 t=0; \
1012if [ -d "$RPM_BUILD_ROOT" ]; then \
1013 find "$RPM_BUILD_ROOT" -name '*.pyc' > __rpm_pyc; \
1014 while read a; do \
1015 b="${a%.pyc}.pyo"; \
1016 if cmp -s "$a" "$b"; then \
1017 ln -f "$a" "$b"; \
1018 c=$((c + 1)); \
1019 fi; \
1020 t=$((t + 1)); \
1021 done < __rpm_pyc; \
1022 [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
1023 rm -f __rpm_pyc; \
1024fi; \
1025}; __spec_install_post_py_hardlink } }
1026
1027# remove python sources, so that check-files won't complain
1028%py_postclean() \
1029for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
1030 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
1031done \
1032%{nil}
1033
1034# depmod macro
1035%depmod() { \
1036umask 022; \
1037if [ -e /boot/System.map-%1 ]; then \
1038 /sbin/depmod -a -F /boot/System.map-%1 %1; \
1039else \
1040 if [ -e /boot/System.map ]; then \
1041 /sbin/depmod -a -F /boot/System.map %1; \
1042 else \
1043 /sbin/depmod -a %1; \
1044 fi \
1045fi; \
1046}
1047
1048# XMMS specific macros
1049%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
1050%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
1051%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
1052%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
1053%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
1054%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
1055%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
1056%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
1057%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
1058%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
1059
1060%_target_base_arch %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/;s/sparcv./sparc/;s/arm.*/arm/')}%_target_base_arch
1061
1062# user/group checking macros
1063#
1064# Usage:
1065# %userremove myuser
1066#
1067%userremove /usr/lib/rpm/user_group.sh user del
1068%groupremove /usr/lib/rpm/user_group.sh group del
1069#
1070# Usage:
1071# if %usertestrm myuser; then
1072# /usr/sbin/userdel -r myuser
1073# Note:
1074# use these macros only if you need to call userdel/groupdel with
1075# a non-standard option or take an extra action; otherwise use the
1076# %userremove/%groupremove macros
1077#
1078%usertestrm /usr/lib/rpm/user_group.sh user testrm
1079%grouptestrm /usr/lib/rpm/user_group.sh group testrm
1080# user group membership management macros
1081#
1082# Usage:
1083# %addusertogroup [-q] myuser agroup
1084#
1085# -q if user or group don't exist, don't make big noise of it (MISSINGOK behaviour)
1086#
1087# Requirements:
1088# BuildRequires: rpmbuild(macros) >= 1.515
1089%addusertogroup(q) quiet=%{-q:1} /usr/lib/rpm/user_group.sh user addtogroup %*; \
1090%{nil}
1091
1092# banner support (useful in {pre,post}{,un} and triggers)
1093#
1094# Usage:
1095# %banner name [-a] [-e] [-n] [-tn] [-o] <<EOF
1096# the banner text, the banner text
1097# the banner text, and following line
1098#EOF
1099# You can use any form of here-document, <<'EOF' <<-EOT will do.
1100# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
1101#
1102# -a - append to the banner
1103# -e - send to stderr instead of stdout
1104# -n - no show banner (overrides -t)
1105# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
1106# -o - show only once, i.e when package is installed for the first time
1107#
1108# Tests:
1109# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1110# (rpm -E '%banner -o -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1111# (rpm -E '%banner -o -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m 1
1112# rpm -E 'date | %banner -e banner' > m; sh -x m
1113# rpm -E 'date | %banner -o -e banner' > m; sh -x m
1114#
1115%banner(aenot:) %{-o:([ "$1" != 1 ] ||} ( \
1116RPM_SCRIPTVERBOSITY=5 \
1117[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
1118if [ -x /usr/bin/banner.sh ]; then \
1119 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1120else \
1121 CMD="cat%{-e: >&2}" \
1122fi \
1123eval $CMD %{?2:%2}%{?3: %3})%{-o:)} \
1124%{nil}
1125
1126# useradd/groupadd macros
1127# Author: Elan Ruusamäe <glen@pld-linux.org>
1128#
1129# Usage:
1130# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
1131# [-g initial_group] [-G group[,...]] login
1132#
1133# -u uid. REQUIRED
1134# -g gid/group. REQUIRED
1135# -s defaults to /bin/false
1136# -d defaults to /usr/share/empty
1137# -c No default
1138# -r is accepted but ignored (it's always set)
1139# -k skeleton dir. defaults to /usr/share/empty
1140# rpm specific flags
1141# -P package name. defaults to %{name}
1142#
1143%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
1144%{!-u:%{error:useradd: Required argument -u missing}} \
1145%{!-g:%{error:useradd: Required argument -g missing}} \
1146%{!?1:%{error:useradd: Required parameter login missing}} \
1147if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
1148 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
1149 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1150 exit 1 \
1151 fi \
1152else \
1153 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
1154 /usr/sbin/useradd \\\
1155 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
1156 -u %{-u*} \\\
1157 -r \\\
1158 -d %{-d*}%{!-d:/usr/share/empty} \\\
1159 -s %{-s*}%{!-s:/bin/false} \\\
1160 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
1161 -g %{-g*} \\\
1162 %{-M} \\\
1163 %{-G:-G %{-G*}} \\\
1164 %{expand:%{%{#}}} 1>&2 || exit $? \
1165 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
1166fi;
1167# vim: "
1168
1169# Usage:
1170# %groupadd [-P package] [-g gid] group
1171#
1172# -g gid. REQUIRED
1173#
1174# Sample:
1175# %groupadd -P %{name}-base -g %{gid} %{name}
1176
1177%groupadd(g:P:rfo) \
1178%{!-g:%{error:groupadd: Required argument -g missing}} \
1179%{!?1:%{error:groupadd: Required parameter group missing}} \
1180if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
1181 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
1182 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1183 exit 1 \
1184 fi \
1185else \
1186 echo "Adding group %{1} GID=%{-g*}." \
1187 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
1188 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
1189fi;
1190
1191# webapp macros
1192# Author: Elan Ruusamäe <glen@pld-linux.org>
1193#
1194# The config is installed/removed inside trigger, this means that you can any
1195# time install apache1/apache/lighttpd package and the configuration file is
1196# updated. if you don't need the config for various reason for specific
1197# webserver, just remove the symlink from config directory using webapp
1198# program. the trigger will not recreate the symlink on upgrades. In other
1199# words the config is linked to webserver config directory on first install of
1200# PACKAGE or WEBSERVER.
1201#
1202# Add package's webserver config to webserver webapps dir.
1203# Usage:
1204# %webapp_register [-f] WEBSERVER WEBAPP
1205#
1206%webapp_register(f) \
1207%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
1208if [ -n "%{-f:1}" ] || [ "$1" = "1" ] && [ "$2" = "1" ]; then\
1209 /usr/sbin/webapp register %1 %2\
1210fi\
1211# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
1212if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
1213 %{expand:%service -q %%1 reload}\
1214fi\
1215%{nil}
1216
1217# Remove package's config from webserver webapps dir.
1218# Usage:
1219# %webapp_register [-f] WEBSERVER WEBAPP
1220%webapp_unregister(f) \
1221%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
1222# remove link if either of the packages are gone \
1223if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
1224 /usr/sbin/webapp unregister %1 %2\
1225 %{expand:%service -q %%1 reload}\
1226fi \
1227%{nil}
1228
1229# service macro.
1230# Author: Elan Ruusamäe <glen@pld-linux.org>
1231#
1232# calls usual service restart on package %post, but skips the restart if
1233# administrator has disabled automatic service restarts in either global
1234# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1235#
1236# Usage:
1237# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
1238#
1239# -q be silent when service isn't started (for scriplets restaring other package's services)
1240# -n NOOP mode, do not actually restart service
1241#
1242# Requirements:
1243# BuildRequires: rpmbuild(macros) >= 1.268
1244# Requires: rc-scripts
1245# -n option:
1246# BuildRequires: rpmbuild(macros) >= 1.450
1247%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
1248
1249
1250# Java macros. based on jpackage macros.java
1251#
1252# Root directory where all Java VMs/SDK/JREs are installed.
1253%_jvmdir %{_libdir}/jvm
1254
1255# Root directory where all Java VMs/SDK/JREs expose their jars
1256%_jvmjardir %{_libdir}/jvm-exports
1257
1258# Root directory for all Java VM/SDK/JRE's private things.
1259%_jvmprivdir %{_libdir}/jvm-private
1260
1261# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
1262%_jvmlibdir %{_libdir}/jvm
1263
1264# Root directory for all architecture independent parts of Java VM/SDK/JRE's
1265%_jvmdatadir %{_datadir}/jvm
1266
1267# Root directory for all configurations parts of Java VM/SDK/JRE's
1268%_jvmsysconfdir %{_sysconfdir}/jvm
1269
1270# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
1271%_jvmcommonlibdir %{_libdir}/jvm-common
1272
1273# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
1274%_jvmcommondatadir %{_datadir}/jvm-common
1275
1276# Root directory for all common configurations parts of Java VM/SDK/JRE's
1277%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
1278
1279# Directory where arch-specific (JNI) version-independent jars are installed.
1280%_jnidir %{_libdir}/java
1281
1282
1283# JDK selection. Set this to name of the JDK implementation to use
1284# insead of the system default
1285#%use_jdk icedtea6
1286
1287# expands to the value with right jdk for BuildRequires header
1288# 'jdk' if %%use_jdk is not defined, jdk(%%use_jdk) otherwise
1289# The requirement will not replace current 'default' JDK
1290%required_jdk jdk%{?use_jdk:(%{use_jdk})}
1291
1292%buildrequires_jdk BuildRequires: %required_jdk
1293
1294%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm}%{?use_jdk:JAVA_HOME=%{_jvmdir}/%{use_jdk}}; echo ${JAVA_HOME:-ERROR})}%java_home
1295
1296%_javasrcdir %{_usrsrc}/java
1297
1298%ant JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
1299%jar %{java_home}/bin/jar
1300%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd}%{?use_jdk:JAVACMD=%{java_home}/bin/java}; echo $JAVACMD)}%java
1301%javac %{java_home}/bin/javac
1302%javadoc %{java_home}/bin/javadoc
1303
1304%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
1305
1306%jpackage_script() \
1307install -d $RPM_BUILD_ROOT%{_bindir}\
1308cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
1309#!/bin/sh\
1310#\
1311# %{name} script\
1312# JPackage Project <http://www.jpackage.org/>\
1313\
1314# Source functions library\
1315. %{_javadir}-utils/java-functions\
1316\
1317# Source system prefs\
1318if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
1319 . %{_sysconfdir}/java/%{name}.conf\
1320fi\
1321\
1322# Source user prefs\
1323if [ -f $HOME/.%{name}rc ]; then\
1324 . $HOME/.%{name}rc\
1325fi\
1326\
1327# Configuration\
1328MAIN_CLASS=%1\
1329BASE_FLAGS=%2\
1330BASE_OPTIONS=%3\
1331BASE_JARS="%(echo %4 | tr ':' ' ')"\
1332\
1333# Set parameters\
1334set_jvm\
1335set_classpath $BASE_JARS\
1336set_flags $BASE_FLAGS\
1337set_options $BASE_OPTIONS\
1338\
1339# Let's start\
1340run "$@"\
1341EOF
1342
1343# jpackage 1.7
1344# Directory for maven depmaps
1345#
1346%_mavendepmapdir /etc/maven
1347%_mavendepmapfragdir /etc/maven/fragments
1348
1349#
1350# add_to_depmap adds an entry to the depmap. The arguments are:
1351#
1352# %1 the original groupid
1353# %2 the original artifact id
1354# %3 the version
1355# %4 the new groupid
1356# %5 the new artifactid
1357#
1358
1359%add_to_maven_depmap() \
1360install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1361cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1362<dependency>\
1363 <maven>\
1364 <groupId>%1</groupId>\
1365 <artifactId>%2</artifactId>\
1366 <version>%3</version>\
1367 </maven>\
1368 <jpp>\
1369 <groupId>%4</groupId>\
1370 <artifactId>%5</artifactId>\
1371 <version>%3</version>\
1372 </jpp>\
1373</dependency>\
1374\
1375EOF\
1376%{nil}
1377
1378#==============================================================================
1379#
1380# update_maven_depmap updates the main maven depmap
1381#
1382%update_maven_depmap() \
1383echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1384if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1385cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1386fi\
1387echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1388
1389# JAVA macros specific for PLD
1390
1391# Directory for tomcat context configuration files
1392%_tomcatconfdir %{_sharedstatedir}/tomcat/conf/Catalina/localhost
1393
1394# Tomcat cache path
1395%_tomcatcachedir %{_sharedstatedir}/tomcat/work/Catalina/localhost
1396
1397# Clear tomcat cache
1398# Author: Paweł Zuzelski <pawelz@pld-linux.org>
1399#
1400# Usage:
1401# %%tomcat_clear_cache appname
1402#
1403# Call this script in %postun scriptlet. It will remove compiled jsps related to
1404# given app.
1405#
1406%tomcat_clear_cache() %{!?1:ERROR}%{?2:ERROR} %{__rm} -rf %{_tomcatcachedir}/%1
1407
1408# PEAR install macros
1409# Author: Elan Ruusamäe <glen@pld-linux.org>
1410#
1411# Usage:
1412# %%pear_package_setup ...
1413#
1414# -a # - also unpack SOURCE#. for PEAR bootstrapping
1415# -n FMT - create builddir with FMT, instead of default %%{pearname}-%%{version}
1416# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1417# -D - pass -D to %setup (so the build dir is not removed)
1418# -c - register channel from local channel.xml file
1419# -d - pass -d arg to pearcmd
1420#
1421# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1422# destination hierarchy. you should copy the tree to buildroot after
1423# patching/reorganizing with %%pear_package_install.
1424#
1425# additionally BUILDROOT is stripped from files and files are converted to UNIX
1426# line endings.
1427#
1428# the pear install process output is recorded to install.log, you should put it
1429# to %%doc for later debug or just for information.
1430#
1431# additionally additional-packages.txt is produced if it was detected that the
1432# package has optional dependencies. the file format is suitable of displaying
1433# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1434# automatically added for this file.
1435
1436
1437# records install.log and transforms PEAR names to PLD Linux rpm package names.
1438%__pear_install_log \
1439tee install.log \
1440# make post message of optional packages \
1441grep -E 'can optionally use|Optional feature' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,' > optional-packages.txt \
1442if [ -s optional-packages.txt ]; then \
1443 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1444else \
1445 rm -f optional-packages.txt \
1446fi \
1447%{nil}
1448
1449# Command invoking PEAR CLI
1450# Same as /usr/bin/pear, except we force GMT timezone
1451%__pear %__php -doutput_buffering=1 -dopen_basedir="" -dmemory_limit=-1 -ddate.timezone=GMT %{php_pear_dir}/pearcmd.php
1452
1453%pear_install(a:d:n:zD) \
1454%__pear \\\
1455 -c %{builddir}/pearrc \\\
1456 -d doc_dir=/docs \\\
1457 -d temp_dir=/tmp \\\
1458 -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
1459 -d bin_dir=%{_bindir} \\\
1460 -d data_dir=%{php_pear_dir}/data \\\
1461 -d test_dir=%{php_pear_dir}/tests \\\
1462 %{-d:%(echo "%{-d*}" | awk 'BEGIN{RS=","}{printf("-d %%s \\\\\\n\\t", $1)}')} \\\
1463 install \\\
1464 --packagingroot=%{builddir} \\\
1465 --offline \\\
1466 --nodeps \\\
1467 %{-f:--force} \\\
1468 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1469 %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
1470%{nil}
1471
1472# The main macro.
1473# using this macro will append optional-packages.txt to the nocompressdoc list
1474# as it's displayed to user after package install. and adding additional gzip
1475# dep is just waste ;)
1476%pear_package_setup(a:d:n:zDc:) \
1477%define srcdir %{-n*}%{!-n:%{?_pearname}%{!?_pearname:%{pearname}}-%{version}} \
1478%define builddir %{_builddir}/%{srcdir} \
1479%setup -q -c -T %{-D:-D} -n %{srcdir} \
1480%{-z:%{__tar} zxf %{S:0}; %{-a:%{__tar} zxf %{S:%{-a*}}}} \
1481%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1482%{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
1483%pear_install \
1484%{-z:cd ..} \
1485%{__tar} --wildcards -zvxf %{S:0} package*.xml \
1486cat %{-z:$_N/}.install.log | %__pear_install_log \
1487%undos -f php,html,js,xml \
1488%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1489%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1490%{nil}
1491
1492# Copies extracted PEAR package structure and PEAR registry to buildroot.
1493# Author: Elan Ruusamäe <glen@pld-linux.org>
1494%pear_package_install() \
1495cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1496# tests should not be packaged \
1497%{__rm} -rf $RPM_BUILD_ROOT%{php_pear_dir}/tests \
1498# cleanup backups \
1499find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1500# help the developer out a little: \
1501if [ -f _noautoreq ]; then \
1502 echo "AutoReqdep detected:" \
1503 echo "_noautoreq $(cat _noautoreq)" \
1504fi \
1505%{nil}
1506
1507# Print optional package info for pear packages
1508# Author: Elan Ruusamäe <glen@pld-linux.org>
1509# Usage:
1510# %post -p <lua>
1511# %%pear_package_print_optionalpackages
1512#
1513# Requirements:
1514# BuildRequires: rpmbuild(macros) >= 1.571
1515%pear_package_print_optionalpackages \
1516f = io.open("%{_docdir}/%{name}-%{version}/optional-packages.txt", "r") \
1517if f then \
1518 for l in f:lines() do print(l); end \
1519end \
1520%{nil}
1521
1522
1523# Register OpenLDAP schema.
1524# Author: Elan Ruusamäe <glen@pld-linux.org>
1525#
1526# Usage:
1527# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1528#
1529# -d specify dependant schemas, separated by comma
1530#
1531%openldap_schema_register(d:) \
1532for schema in %*; do \
1533 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1534 %{__sed} -i -e " \
1535 /^include.*local.schema/{ \
1536 iinclude\\t $schema\
1537 } \
1538 " /etc/openldap/slapd.conf \
1539 fi \
1540done \
1541# enable dependant schemas \
1542if [ "%{-d*}" ]; then \
1543 %{__sed} -i -e ' \
1544 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1545 s/^#// \
1546 }' /etc/openldap/slapd.conf \
1547fi \
1548%{nil}
1549
1550# Unregister OpenLDAP schema.
1551# Author: Elan Ruusamäe <glen@pld-linux.org>
1552#
1553# Usage:
1554# %%openldap_schema_unregister %{schemadir}/horde.schema
1555#
1556%openldap_schema_unregister() \
1557for schema in %*; do \
1558 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1559 %{__sed} -i -e " \
1560 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1561 # for symmetry it would be nice if we disable enabled schemas in post, \
1562 # but we really can not do that, it would break something else. \
1563 " /etc/openldap/slapd.conf \
1564 fi \
1565done \
1566%{nil}
1567
1568%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1569
1570
1571# Build modules for kernels 2.6
1572# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1573#
1574# Usage:
1575# %build_kernel_modules -m <modules> -C <directory>
1576#
1577# remember that proper Makefile is still required
1578# Options:
1579# -m <modules> (required) -- comma-separated list of modules to save,
1580# without .ko extension, may be placed in subdirectory
1581# -C <directory> -- change to <directory> before doing anything
1582# -p <arg>, -P <arg> -- arguments passeed to make scripts
1583# -c -- do not execute make clean
1584# <additional arguments> -- all additional arguments will be passed to
1585# make modules
1586#
1587# Additional patching supported via here document. Try:
1588# %build_kernel_modules -m module <<'EOF'
1589# your patch script here
1590# EOF
1591# Don't use it unless patching depends on config options.
1592
1593# Developer note: don't touch it unless you know how to handle '\'.
1594# - \ in script expands to nothing
1595# - \\\ in script expands to \
1596# - \\\ inside definition expands to nothing
1597# - \\\\\\\ inside definition expands to \
1598# - in last line \ has to touch arguments so arguments passing
1599# in new lines (using \) will be supported
1600
1601%build_kernel_modules(p:P:m:C:c) \
1602%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1603 \
1604%define Opts \\\\\\\
1605%if "%{_target_base_arch}" != "%{_arch}" \\\
1606 %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
1607 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
1608 %else \\\
1609 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1610 %endif \\\
1611%else \\\
1612 CC="%{kgcc}" \\\
1613%endif \
1614%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1615 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1616 \
1617%{?-C:cd %{-C*}} \
1618compile() { \
1619 local L="<" PATCH_SH; \
1620 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
1621 set -e -x \
1622 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1623 \
1624for cfg in ${cfgs:-dist}; do \
1625 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1626 \
1627 rm -rf o \
1628 install -d o/include/linux o/include/generated o/arch/powerpc/lib \
1629 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1630 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
1631 if [ -f %{_kernelsrcdir}/include/generated/autoconf-$cfg.h ]; then \
1632 ln -sf %{_kernelsrcdir}/include/generated/autoconf-$cfg.h o/include/generated/autoconf.h \
1633 ln -s ../generated/autoconf.h o/include/linux/autoconf.h \
1634 else \
1635 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1636 fi \
1637 \
1638 set +x \
1639 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1640 set -x \
1641 \
1642 %if %{with dist_kernel} || %(test -f %{_kernelsrcdir}/scripts/bin2c ; echo $?) \
1643 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1644 %{-p*} %{-P*} \\\
1645 %{MakeOpts} \
1646 %else \
1647 install -d o/include/config \
1648 touch o/include/config/MARKER \
1649 ln -sf %{_kernelsrcdir}/include/config/auto-$cfg.conf o/include/config/auto.conf \
1650 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1651 %endif \
1652 \
1653 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
1654 RCS_FIND_IGNORE="-name '*.[ks]o' -o" \\\
1655 ${1+"$@"} \\\
1656 M=$PWD %{MakeOpts}} \
1657 \
1658 %{__make} -C %{_kernelsrcdir} modules \\\
1659 ${1+"$@"} \\\
1660 M=$PWD CONSTIFY_PLUGIN="" %{MakeOpts} \
1661 \
1662 for MODULE in {%{-m*},}; do \
1663 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1664 done \
1665done \
1666%{?-C:cd -} \
1667} \
1668compile %{*}\
1669%{nil}
1670
1671
1672# Install kernel modules built by %build_kernel_modules
1673# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1674#
1675# Usage:
1676# %install_kernel_modules -m <modules> -d <directory>
1677#
1678# Options:
1679# -m <modules> (required) -- comma-separated list of modules to install,
1680# without .ko extension, may be placed in subdirectory
1681# -d <directory> (required) -- in what subdirectory modules should be
1682# installed (eg. misc, kernel/drivers/net)
1683# -s <suffix> -- suffix to use when installing modules, useful when module
1684# with same name exists in kernel already
1685# -n <file> -- name of modprobe config file to use (without .conf extension)
1686# for defining aliases, only useful with -s
1687
1688%install_kernel_modules(m:d:s:n:) \
1689%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1690%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1691%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1692 \
1693%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1694%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1695 \
1696__install_kernel_modules() { \
1697%{!?debug:set +x;} \
1698local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1699 \
1700for MODULE in {%{-m*},}; do \
1701 [ -n "${MODULE}" ] || continue \
1702 for cfg in ${cfgs:-dist}; do \
1703 [ "$cfg" = smp ] && suf=smp || suf= \
1704 MNAME=${MODULE##*/} \
1705 install -D ${MODULE}-$cfg.ko \\\
1706 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
1707 %{?-s:install -d %{ModprobeD}$suf \
1708 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1709 >> %{ModprobeD}$suf/%{-n*}.conf} \
1710 done \
1711done \
1712} \
1713__install_kernel_modules \
1714%{nil}
1715
1716# patchset macros
1717# Author: Elan Ruusamäe <glen@pld-linux.org>
1718#
1719# Usage:
1720# %patchset_source -f <seq(1) format> <start> [<end>]
1721# %patchset_patch <start> [<end>]
1722#
1723# If <end> is omited, it is assumed to be <start>.
1724#
1725# For example in preamble:
1726# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1727# and in %prep:
1728# %patchset_patch 33 44
1729
1730# generate SourceX urls from range START STOP
1731# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1732# The sources start from 10000
1733%patchset_source(f:b:) %(
1734 base=%{-b*}%{!-b*:10000};
1735 start=$(expr $base + %1);
1736 end=$(expr $base + %{?2}%{!?2:%{1}});
1737 # we need to call seq twice as it doesn't allow two formats
1738 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1739 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1740 paste %{tmpdir}/__ps{1,2};
1741 rm -f %{tmpdir}/__ps{1,2};
1742) \
1743%{nil}
1744
1745# apply sources from %patchset_source
1746# -p specify -pX for %patch line
1747# -b base offset: defaults to 10000
1748%patchset_patch(f:p:b:) %(
1749 base=%{-b*}%{!-b*:10000};
1750 start=$(expr $base + %1);
1751 end=$(expr $base + %{?2}%{!?2:%{1}});
1752 echo ": patchset_patch %1%{?2: to %2}";
1753 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1754) \
1755%{nil}
1756
1757# browser plugins v2
1758# Author: Elan Ruusamäe <glen@pld-linux.org>
1759#
1760# Usage:
1761# %browser_plugins_add_browser <name> -p <plugindir>
1762#
1763# <name> (required) -- name of the browser. usually %{name}.
1764# -p <plugindir> (required) -- in what directory browser searches for its plugins.
1765# -b -- default blacklists
1766# -a <arch> override arch
1767#
1768# Example:
1769# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1770
1771%_browserpluginsconfdir /etc/browser-plugins
1772%_browserpluginsdir %{_libdir}/browser-plugins
1773%update_browser_plugins /usr/sbin/update-browser-plugins || :
1774
1775%browser_plugins_add_browser(p:b:a:) \
1776 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1777 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1778 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1779 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1780 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1781 %{-b:cat >> $blacklist_file %{-b*}} \
1782%{nil}
1783
1784# Helper for LUA.
1785# split string separated by space into quoted list
1786#
1787# Author: Elan Ruusamäe <glen@pld-linux.org>
1788#
1789# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1790%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1791
1792# adjust /etc/shells by adding and removing shells from there
1793# Author: Elan Ruusamäe <glen@pld-linux.org>
1794#
1795# Usage:
1796# %post -p <lua>
1797# %lua_add_etc_shells /bin/sh /bin/pdksh
1798#
1799# %preun -p <lua>
1800# if arg[2] == 0 then
1801# %lua_remove_etc_shells /bin/bash /bin/rbash
1802# end
1803#
1804# Requirements:
1805# BuildRequires: rpmbuild(macros) >= 1.462
1806#
1807
1808%lua_add_etc_shells() \
1809t = {}\
1810f = io.open("/etc/shells", "r")\
1811if f then\
1812 for l in f:lines() do t[l]=l; end\
1813 f:close()\
1814end\
1815for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1816 if not t[s] then\
1817 print("Adding "..s.." to /etc/shells")\
1818 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1819 end\
1820end\
1821%{nil}
1822
1823%lua_remove_etc_shells() \
1824t = {}\
1825f = io.open("/etc/shells", "r")\
1826if f then\
1827 for l in f:lines() do t[l]=l; end\
1828 f:close()\
1829end\
1830for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1831 print("Removing "..l.." from /etc/shells")\
1832 t[l] = nil\
1833end\
1834s=""\
1835for _, l in pairs(t) do\
1836 s=s..l.."\\n"\
1837end\
1838io.open("/etc/shells", "w"):write(s)\
1839%{nil}
1840
1841# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1842#
1843# Author: Elan Ruusamäe <glen@pld-linux.org>
1844#
1845# Usage:
1846# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1847# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1848#
1849# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1850#
1851# Requirements:
1852# BuildRequires: rpmbuild(macros) >= 1.429
1853#
1854%add_etc_shells(p) %{-p:<lua>}\
1855%{expand:%%lua_add_etc_shells %*}\
1856%{nil}
1857
1858%remove_etc_shells(p) %{-p:<lua>}\
1859%{-p:if arg[2] == 0 then}\
1860%{expand:%%lua_remove_etc_shells %*}\
1861%{-p:end} \
1862%{nil}
1863
1864# Check syntax for Python files
1865#
1866# Author: Elan Ruusamäe <glen@pld-linux.org>
1867# Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1868#
1869# Usage:
1870# %py_lint src
1871#
1872# Requirements:
1873# BuildRequires: python
1874# BuildRequires: rpmbuild(macros) >= 1.602
1875
1876%py_lint() \
1877__py_lint() { \
1878%{!?debug:set +x;} \
1879find "$@" -type f -name '*.py' | python -c ' \
1880import sys \
1881import compiler \
1882\
1883found = err = 0\
1884for f in sys.stdin: \
1885 fd = open(f.rstrip()) \
1886 c = fd.read() \
1887 fd.close() \
1888 found = found + 1 \
1889 try: \
1890 compiler.parse(c) \
1891 except SyntaxError, e: \
1892 print "py_lint: %s: %s" % (f.rstrip(), e) \
1893 err = err + 1\
1894\
1895if not found:\
1896 print >> sys.stderr, "\\npy_lint: ERROR: No files processed.\\n" \
1897 sys.exit(1) \
1898elif err: \
1899 print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
1900 sys.exit(1) \
1901else: \
1902 print >> sys.stderr, "py_lint: %d files scanned, found no syntax errors." % found \
1903' \
1904}; __py_lint %* \
1905%{nil}
1906
1907# Undos files
1908#
1909# Author: Paweł Zuzelski <pawelz@pld-linux.org>
1910# Author: Elan Ruusamäe <glen@pld-linux.org>
1911#
1912# Usage:
1913# %undos list_of_files
1914# %undos -f EXT[,EXT]
1915# %undos -i -f EXT[,EXT]
1916#
1917# -f EXT[,EXT] - find(1) files by extensions
1918# -i - case insensitive file search
1919#
1920# Example:
1921# Un-DOS all *.js, *.css files
1922# %undos -f js,css
1923# Un-DOS all *.js, *.JS files
1924# %undos -f js -i
1925# undos all Makefiles
1926# %{__find} -name Makefile | xargs %undos
1927#
1928# Requirements:
1929# BuildRequires: sed >= 4.0
1930# BuildRequires: rpmbuild(macros) >= 1.565
1931
1932# NB: make sure this macro stays on one line
1933# NB: make sure it includes newline escape
1934%undos(f:i) %{-f:%{__find} -regextype posix-extended -%{-i:i}regex '^.+\\.(%(echo %{-f*} | tr ',' '|'))$' -print0 | xargs -0} %{__sed} -i -e 's,\\r$,,' %* \
1935%{nil}
1936
1937# Hook to register nagios object based plugins in Nagios NRPE daemon config.
1938#
1939# Author: Elan Ruusamäe <glen@pld-linux.org>
1940#
1941# Usage:
1942# -a NAME -- add command named NAME
1943# -d NAME -- remove command named NAME
1944# -f FILE -- specify plugin configuration FILE to extract command definition from
1945#
1946# Sample:
1947# %triggerin -- nagios-nrpe
1948# %nagios_nrpe -a %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
1949#
1950# %triggerun -- nagios-nrpe
1951# %nagios_nrpe -d %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
1952#
1953# Requirements:
1954# Requires: grep
1955# Requires: sed >= 4.0
1956# BuildRequires: rpmbuild(macros) >= 1.552
1957%nagios_nrpe(a:d:c:f:) {\
1958 m=$(md5sum < /etc/nagios/nrpe.cfg); \
1959 %{-a:# on -a and config exists \
1960 if [ -f /etc/nagios/nrpe.cfg ]; then \
1961 if ! %{__grep} -q '^command\[%{-a*}\]' /etc/nagios/nrpe.cfg; then \
1962 %{__sed} -ne 's/^[ \t]*command_line[ \t]\+\(.\+\)/command[%{-a*}]=\1/p' %{-f*} >> /etc/nagios/nrpe.cfg; \
1963 fi; \
1964 fi;} \
1965 %{-d:# on package remove, -d and config exists \
1966 if [ "$1" = "0" -a -f /etc/nagios/nrpe.cfg ]; then \
1967 %{__sed} -i -e '/^[ \t]*command\[%{-d*}\]/d' /etc/nagios/nrpe.cfg; \
1968 fi;} \
1969 if [ "$m" != "$(md5sum < /etc/nagios/nrpe.cfg)" ]; then \
1970 %service -q nrpe restart; \
1971 fi; \
1972}%{nil}
1973
1974# Import or update Cacti template.
1975#
1976# Author: Elan Ruusamäe <glen@pld-linux.org>
1977#
1978# Usage:
1979# %cacti_import_template XMLFILE
1980# XMLFILE -- XML template to import
1981#
1982# Sample:
1983# %post
1984# %cacti_import_template %{resourcedir}/cacti_host_template_varnish.xml
1985#
1986# Requires: cacti >= 0.8.7e-8
1987# BuildRequires: rpmbuild(macros) >= 1.630
1988# Note: 1.1 (cacti-0.8.7h) adds requirement for --with-template-rras or --with-user-rras option
1989
1990%cacti_import_template() {\
1991v=$(%{__sed} -rne 's/.+Add Graphs Script ([0-9\.]+).+/\1/p' /usr/share/cacti/cli/import_template.php); \
1992if [ "$v" != "1.0" ]; then \
1993 rra="--with-template-rras"; \
1994fi; \
1995/usr/share/cacti/cli/import_template.php --filename=%1 $rra || :; \
1996}%{nil}
1997
1998# pre/post script for -upstart subpackages
1999#
2000# Author: Jacek Konieczny <jajcus@jajcus.net>
2001#
2002# Usage:
2003# %upstart_post service_name
2004# %upstart_postun service_name
2005#
2006# Sample:
2007# %post upstart
2008# %upstart_post %{name}
2009#
2010# %postun upstart
2011# %upstart_postun %{name}
2012#
2013# Requirements:
2014# BuildRequires: rpmbuild(macros) >= 1.560
2015# Requires: rc-scripts >= 0.4.3
2016
2017# migrate from init script to upstart job
2018%upstart_post() \
2019 if [ -f /var/lock/subsys/%1 ]; then \
2020 /sbin/service --no-upstart %1 stop \
2021 /sbin/service %1 start \
2022 fi
2023
2024# restart the job after upgrade or migrate to init script on removal
2025# cannot be stopped with 'service' as /etc/init/$name.conf may be missing
2026# at this point
2027%upstart_postun() \
2028 if [ -x /sbin/initctl ] && /sbin/initctl status %1 2>/dev/null | grep -q 'running' ; then \
2029 /sbin/initctl stop %1 >/dev/null 2>&1 \
2030 [ -f /etc/rc.d/init.d/%1 -o -f /etc/init/%1.conf ] && { echo -n "Re-"; /sbin/service %1 start; }; \
2031 fi
2032
2033# Haskell Macros
2034# BuildRequires: rpmbuild(macros) >= 1.608
2035%ghcdir ghc-%(/usr/bin/ghc --numeric-version 2>/dev/null || echo ERROR)
2036
2037# update /usr/lib*/ghc-*/package.conf.d/package.cache
2038# Requires: ghc
2039# BuildRequires: rpmbuild(macros) >= 1.607
2040#
2041%ghc_pkg_recache() {{ \
2042 umask 022; \
2043 /usr/bin/ghc-pkg recache; \
2044};} \
2045%{nil}
2046
2047
2048# pre/post script for -systemd subpackages
2049#
2050# Author: Bartlomiej Zimon <uzi18@o2.pl>
2051#
2052# Usage:
2053# %systemd_reload
2054# %systemd_post service_name1.service service_name2.service
2055# %systemd_preun service_name1.service service_name2.service
2056#
2057# Sample:
2058# %post systemd
2059# %systemd_reload
2060# or if service must be enabled by default:
2061# %post systemd
2062# %systemd_post %{name}.service
2063#
2064# %preun systemd
2065# %systemd_preun %{name}.service
2066#
2067# %postun systemd
2068# %systemd_reload
2069#
2070# Requirements:
2071# BuildRequires: rpmbuild(macros) >= 1.627
2072# Requires: systemd-units >= 37-0.10
2073
2074%systemd_reload /bin/systemd_booted && SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog /bin/systemctl --quiet daemon-reload || :
2075
2076%systemd_post() \
2077 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2078 /bin/systemd_booted && /bin/systemctl --quiet daemon-reload || : \
2079 if [ $1 -eq 1 ]; then \
2080 /bin/systemctl --quiet enable %{*} || : \
2081 fi \
2082 if [ $1 -gt 1 ] && [ -z "$NORESTART" ]; then \
2083 /bin/systemctl --quiet try-restart %{*} || : \
2084 fi \
2085%{nil}
2086
2087%systemd_preun() \
2088 if [ $1 -eq 0 ]; then \
2089 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog; \
2090 /bin/systemctl --no-reload --quiet disable %{*} || : \
2091 if /bin/systemd_booted; then \
2092 /bin/systemctl --quiet stop %{*} || : \
2093 fi \
2094 fi \
2095%{nil}
2096
2097%systemdunitdir /lib/systemd/system
2098
2099# EOF
This page took 0.104175 seconds and 4 git commands to generate.